<?php defined('SYSPATH') or die('No direct script access.');
  
class Model_Map extends Model
{
    public static function addModuleBonus($teacherID, $disciplineID)
    {
        $sql = "SELECT `AddModuleBonus`('$teacherID', '$disciplineID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function deleteModuleBonus($teacherID, $disciplineID)
    {
        $sql = "SELECT `DeleteModuleBonus`('$teacherID', '$disciplineID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function addModule($teacherID, $disciplineID, $title)
    {
        $db = Database::instance();
        $title = $db->escape($title);
        $sql = "SELECT `AddModule`('$teacherID', '$disciplineID', $title) AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function deleteModule($teacherID, $moduleID)
    {
		$sql = "SELECT `DeleteModule`('$teacherID', '$moduleID') AS `Num`;";
		return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function changeModuleName($teacherID, $moduleID, $Name)
    {
        $db = Database::instance();
        $Name = $db->escape($Name);
        $sql = "SELECT `ChangeModuleName`('$teacherID', '$moduleID', $Name) AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function addSubmodule($teacherID, $moduleID, $maxRate, $title, $description, $typeControl)
    {
        $sql = "SELECT `AddSubmodule`('$teacherID', '$moduleID', '$maxRate', '$title', '$description', '$typeControl') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function deleteSubmodule($teacherID, $submoduleID)
    {
        $sql = "SELECT `DeleteSubmodule`('$teacherID', '$submoduleID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function changeSubmoduleName($teacherID, $submoduleID, $Name)
    {
        $db = Database::instance();
        $Name = $db->escape($Name);
        $sql = "SELECT `ChangeSubmoduleName`('$teacherID', '$submoduleID', $Name) AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }





    public static function swapModuleOrder($teacherID, $moduleID1, $moduleID2)
    {
        $sql = "SELECT `SwapModuleOrder`('$teacherID', '$moduleID1', '$moduleID2') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function swapSubmoduleOrder($teacherID, $submoduleID1, $submoduleID2)
    {
        $sql = "SELECT `SwapSubmoduleOrder`('$teacherID', '$submoduleID1', '$submoduleID2') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function changeSubmoduleMaxAndControl($teacherID, $SubmoduleID, $MaxRate, $ControlType)
    {
        $db = Database::instance();
        $ControlType = $db->escape($ControlType);
        $sql = "SELECT `ChangeSubmoduleMaxAndControl`('$teacherID', '$SubmoduleID', '$MaxRate', $ControlType) AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function getMapForDiscipline($disciplineID)
    {
        $sql = "CALL `GetRoadmap`('$disciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function changeDisciplineSubject($teacherID, $DisciplineID, $SubjectID)
    {
        $sql = "SELECT `ChangeDisciplineSubject`('$teacherID', '$DisciplineID', '$SubjectID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function changeDisciplineControl($teacherID, $DisciplineID, $Control)
    {
        $db = Database::instance();
        $Control = $db->escape($Control);
        $sql = "SELECT `ChangeDisciplineControl`('$teacherID', '$DisciplineID', $Control) AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function changeDisciplineHours($teacherID, $DisciplineID, $Hours, $Type)
    {
        $db = Database::instance();
        $Type = $db->escape($Type);
        $sql = "SELECT `ChangeDisciplineHours`('$teacherID', '$DisciplineID', '$Hours', $Type) AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function bindGroup($teacherID, $DisciplineID, $GroupID)
    {
        $sql = "SELECT `BindGroup`('$teacherID', '$DisciplineID', '$GroupID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function unbindGroup($teacherID, $DisciplineID, $GroupID)
    {
        $sql = "SELECT `UnbindGroup`('$teacherID', '$DisciplineID', '$GroupID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function bindStudent($teacherID, $DisciplineID, $StudentID)
    {
        $sql = "SELECT `BindStudent`('$teacherID', '$DisciplineID', '$StudentID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function UnbindStudent($teacherID, $DisciplineID, $StudentID)
    {
        $sql = "SELECT `UnbindStudent`('$teacherID', '$DisciplineID', '$StudentID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    // // deprecated (moved in helpers)
    // public function searchTeachers($FacultyID, $DepartmentID, $Last, $First, $Second) {
    //     $sql = "CALL `SearchTeachers`('$FacultyID', '$DepartmentID', '$Last', '$First', '$Second'); ";
    //     return DB::query(Database::SELECT, $sql)->execute();
    // }
    
    // deprecated (moved in helpers)
    public static function searchTeachers($FacultyID, $DepartmentID, $Name, $DisciplineID)
    {
        $db = Database::instance();
        $Name = $db->escape($Name);
        $sql = "CALL `SearchTeachers`('$FacultyID', '$DepartmentID', $Name, '$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
	

}
