<?php defined('SYSPATH') or die('No direct script access.');

/**
 * @property-read $ID int
 * @property $AuthorID int
 * @property $GradeID int
 * @property $GradeNum int
 * @property $FacultyID int
 * @property $FacultyName string
 * @property $Degree string  bachelor / master
 * @property $SemesterID int
 * @property $Type string
 * @property $Subtype string  Either "scientific" or "disciplinary"
 * @property $IsLocked bool
 * @property $IsBonus bool
 * @property $Milestone mixed
 */
class Model_CourseWork extends Model_Discipline
{
    const SCIENTIFIC = 'scientific_coursework';
    const DISCIPLINARY = 'disciplinary_coursework';

    /** Creation of new course work from raw data. */
    public static function make() {
        return new Model_Helper_CourseWorkBuilder();
    }
}